// 2015/11/04_11:57:55
// U.S. Patents No. 8095582, 8117197, 8442973, 8543570 and 8924378.

//FOR-IE surfcanyonWrapperObject = function() {	var urlParams;
function getUserAgent() {
	var ua = '';

	try {
		ua = navigator.userAgent;
	} catch (e) {
	}

	return ua;
}
var SERP = null;

var ua = getUserAgent();
scIsOldIE = (ua.indexOf('MSIE') > 0);	
scIsIE = scIsOldIE || (ua.indexOf('Trident') > 0);	
scIsFF = (ua.indexOf('Firefox') > 0) && !scIsIE;
scIsChrome = (ua.indexOf('Chrome') > 0);
scIsSafari = (ua.indexOf("Safari") > 0) && !scIsChrome;

scInitializedByBackgroundPage = scIsChrome || scIsSafari;

// set up the logger
(function() {
	logger = {};
	
	getMsg = function(fn, msg) {
		var text = "";
		
		if (typeof fn != "undefined") {
			if (!scIsIE) {
				text = fn.name;
			} else {
				var n = fn.toString();
				n = n.substr(0, n.indexOf('('));
				text = n.replace('function', '').trim();
			}
		}
		
		if ((msg) && msg.length > 0) {
			text += ": " + msg;
		}
		
		return text;
	}
	
	writeLog = function(msg) {		
		if (typeof console != "undefined") {
			console.log(msg);
		}
	};	
	
	logger.log = function(msg) {
		writeLog(getMsg(arguments.callee.caller, msg));
	}
	
	logger.debug = function(msg) {	
		//if ((typeof getBoolPreferenceValue != "undefined") && getBoolPreferenceValue('debug')) {
			writeLog(getMsg(arguments.callee.caller, msg));
		//} 
	}
})();

try {
	function getParams() {
		if (!urlParams) {
			urlParams = {};
			var query = window.location.search.substr(1).split('&');

			for (var i = 0; i < query.length; i++) {
				var param = query[i].split('=');
				if (param.length < 2) {
					continue;
				}
				urlParams[param[0]] = param[1];
			}
		}
		return urlParams;
	}

	function mergeProperties(container, newData) {
		for (var i in newData) {
			if (newData.hasOwnProperty(i)) {
				container[i] = newData[i];
			}
		}
	};

	function appendSafeHtml(html, callback) {
		if (scIsFF) {
			sc_appendSafeHtml(html, callback);
		} else {
			callback(html);
		}
	}

	(function() {
		var config = {};

		// no need for implementing prototypes, as a SERP object
		// will only be created once for the window
		GoogleSERP = function() {
			mergeProperties(config, {
				searchEngine: 'google',
				numResultsToken: ':NR=',
				cookieNewWindowToken: 'NW=1',
				batchSize: 50,
				numSRsForInitialUpload: 50,
				maxSRsToUpload: 100,
				searchQueryCommand: 'search',
				searchQueryTermArgName: 'q',
				searchQueryNumResultsArgName: 'num',
				searchQueryStartResultArgName: 'start',
				footerStartResultArgName: 'start',
				navbarDivName: 'nav'
			});

			this.extractUrlFromSRNode = function (srNode) {
				var url = null;
				var linkNode = srNode.querySelector('h3.r a');
				if (linkNode) {
					url = linkNode.href;
				}
				console.log('extracted URL: ' + url);
				return url;
			};
			this.scGetSRNodes = function () {
				var resultNodes = document.querySelectorAll('div.g');
				var numNodes = resultNodes.length;
				var nodes = [];
				for (var i = 0; i < numNodes; i++) {
					var node = resultNodes[i];
					var url = this.extractUrlFromSRNode(node);
					var h = node.innerHTML;
					if (url) {
						// "div class="med" is a header for interstitial results.
						// "google.x(this,google.rt.pause)" is Latest Results.
						// "_YM" appears in top-of-page wikipedia infobox.
						if (!contains(h, '<div class="med') && !contains(h, 'google.x(this,google.rt.pause)') && !contains(h, "_YM") && !contains(h, 'Pages similar to') && !contains(h, 'oi=local_result')) {
							nodes.push(node);
						}
					}
				}

				return nodes;
			};

			this.getBehavior = function() {
				return config;
			};
		};
	})();

	function getById(name) {
		return document.getElementById(name);
	}

	function getTags(type) {
		return document.getElementsByTagName(type);
	}

	function make(type) {
		return document.createElement(type);
	}

	function startsWith(text, substring) {
		return text && substring && (text.indexOf(substring) === 0);
	}

	function endsWith(text, substring) {
		var b = false;
		if (text && substring) {
			var pos = text.lastIndexOf(substring);
			b = (pos != -1) && (pos == (text.length - substring.length));
		}
		return b;
	}

	function contains(text, substring) {
		return text && substring && (text.indexOf(substring) >= 0);
	}

	function truncateAtSpace(text, pos) {
		if (text) {
			text = text.trim();
			var spacePos = text.indexOf(' ', pos);
			if (spacePos >= pos) {
				text = text.substring(0, spacePos);
			}
		}

		return text;
	}

	function isServerError(s) {
		return s && startsWith(s, '<html><head><title>Apache Tomcat') && contains(s, '<body><h1>HTTP Status ');
	}

	function isOkServerResponse(s) {
		return s && (typeof s !== "undefined") && !isServerError(s);
	}

	function scGetTime() {
		return (Date.now ? Date.now() : (new Date()).getTime()).toString();
	}

	function getResponseText(xhr) {
		return scIsIE ? xhr.httpRequest.responseText : xhr.responseText;
	}

	function scGetText(s) {
		return (s ? (scIsOldIE ? s.text : s.textContent) : '');
	}

	function scXmlParser(text) {
		if (scIsOldIE) {
			var domParser = new ActiveXObject("Microsoft.XMLDOM");
			domParser.async = "false";
			domParser.loadXML(text);
			return domParser;
		} else {
			return (new DOMParser()).parseFromString(text, "text/xml");
		}
	}

	function onLiveServer() {
		return contains(SC.host, 'www');
	}

	function onTestServer() {
		return !onLiveServer();
	}

	function initFF() {
		alert = function (msg) {
			sc_alert(msg);
		};

		setTimeout = function (func, ms) {
			window.setFFTimeout(func, ms);
		};

		clearTimeout = function (func) {
			window.clearTimeout(func);
		};
	}

	function initIE() {
		sc_ajax = function (params) {
			var httpRequest = window.surfcanyonObject.NewHttpRequest();

			var requestWrapper = {};
			requestWrapper.httpRequest = httpRequest;

			var url = params["url"];
			requestWrapper.url = url;

			httpRequest.open(params["method"], url, true);

			var headers = params["headers"];
			if (headers) {
				var header;
				for (header in headers) {
					httpRequest.setRequestHeader(header, headers[header]);
				}
			}

			var onload = params["onload"];
			var onerror = params["onerror"];
			httpRequest.onreadystatechange = function () {
				if (httpRequest.readyState == 4) {
					if (httpRequest.status == 200) {
						if (onload) {
							onload(requestWrapper);
						}
					} else {
						if (onerror) {
							onerror(requestWrapper);
						}
					}
				}
			};
			httpRequest.send(params["data"]);
		};

		EventRecord = function (event) {
			this.srcElement = event.srcElement;
			this.shiftKey = event.shiftKey;
			this.ctrlKey = event.ctrlKey;
			this.metaKey = event.metaKey;
			this.cancelBubble = true;
			this.returnValue = false;
		};

		getBoolPreferenceValue = function (name) {
			return window.surfcanyonObject.GetPreference(name) == 1;
		};

		setBoolPreferenceValue = function (name, value) {
			window.surfcanyonObject.SetPreference(name, value ? 1 : 0);
		};

		getCharPreferenceValue = function (name) {
			return window.surfcanyonObject.GetPreference(name);
		};

		setCharPreferenceValue = function (name, value) {
			window.surfcanyonObject.SetPreference(name, value);
		};

		openNewTab = function (url) {
			window.open(url);
		};
	}

	function cancelEvent(event) {
		if (event) {
			if (event.stopPropagation) {
				event.stopPropagation();
			}
			if (event.preventDefault) {
				event.preventDefault();
			}
			event.cancelBubble = true;
			event.returnValue = false;
		}
	}

	function extractUrlFromSpanTag(spanTag) {
		var url = null;

		if (spanTag) {
			url = removeSimpleHtmlTags(spanTag.innerHTML);

			var endPos = url.indexOf(' - ');
			if (endPos > 0) {
				url = url.substring(0, endPos);
			}
		}

		return url;
	}

	function removeHref(node, addUnderlines) {
		try {
			if (node && node.href) {
				var url = node.href;
				node.setAttribute('scBackupHref', url);
				node.removeAttribute('href');

				node.style.cursor = "pointer";
				if (addUnderlines) {
					node.style.textDecoration = 'underline';
				}

				var args = url.replace(/%26/g, '&').split(/[&\?]/);
				var i;
				for (i = 0; i < args.length; i++) {
					var arg = args[i];
					var sepPos = arg.indexOf('=');
					if (sepPos != -1) {
						var name = arg.substring(0, sepPos);
						if (name === SC.footerStartResultArgName) {

							var start = arg.substring(sepPos + 1);
							node.setAttribute('scGotoPageStartVal', start);
							break;
						}
					}
				}
			}
		} catch (e) {
		}
	}

	function restoreHref(node) {
		try {
			var url = node.getAttribute('scBackupHref');
			node.setAttribute('href', url);
			node.removeAttribute('scBackupHref');
		} catch (e) {}
	}

	function interceptMoreResultsLinks() {
		var navbar = getNavbar();
		var i;
		var addUnderlines = onGoogleSerp();

		var nodes = getChildrenByTagName(navbar, 'a');
		for (i = 0; i < nodes.length; i++) {
			removeHref(nodes[i], addUnderlines);
		}

		if (onGoogleSerp()) {
			nodes = getChildrenByTagName(navbar, 'td');
			for (i = 0; i < nodes.length; i++) {
				var td = nodes[i];
				if (td.className === 'cur') {
					td.className = '';
				}
			}
		}

		return false;
	}

	function containsHtml(s) {
		return s && (s.indexOf('<') >= 0) && (s.indexOf('>') >= 0);
	}

	function getTitleTag(srNode) {
		var title = null;

		if (onGoogleSerp()) {
			var nodes = getChildrenByTagName(srNode, "h3");
			if (nodes.length === 0) {
				nodes = getChildrenByTagName(srNode, "h2");
			}

			if (nodes.length > 0) {
				title = nodes[0];
			} else {
				nodes = getChildrenByTagName(srNode, "a");
				if (nodes.length > 0) {
					title = nodes[0];
				}
			}
		}
		if (title) {
			console.log('title element found!');
		}
		return title;
	}

	function getNavbar() {
		var navbar = getById(SC.navbarDivName);
		if (!navbar) {
			navbar = getElementsByClassName(SC.navbarDivName)[0];
		}
		return navbar;
	}

	function determineLinkType(node) {
		var linkType = null;
		var text;
		var attrVal = node.getAttribute('scGotoPageStartVal');
		if (attrVal) {
			if (onGoogleSerp()) {
				text = node.innerHTML.replace(/\s+$/g, '');
				var lastChar = text.charAt(text.length - 1);
				linkType = (lastChar >= '1' && lastChar <= '9') ? 'Goto' : 'Next';
			}
		}

		return linkType;
	}

	function pruneHtml(html) {
		if (onGoogleSerp()) {
			var pos = html.indexOf('<div id=res');
			if (pos != -1) {
				html = html.substring(pos);
			}

			pos = html.indexOf('<div id="center_col"');
			if (pos != -1) {
				html = html.substring(pos);
			}

			pos = html.indexOf('<!--z--');
			if (pos != -1) {
				html = html.substring(0, pos);
			}

			html = html.replace(/onmousedown=".*?"/g, '');
			html = html.replace(/onmouseover=".*?"/g, '');

			html = html.replace(/<span class=vshid>.*?<\/span>/g, '');
		}

		return html;
	}

	function getElementsByTagAndAttribute(tag, attrName, attrVal) {
		var elements = getTags(tag);
		var arr = [],
		i,
		len = elements.length;
		for (i = 0; i < len; i++) {
			var element = elements[i];
			if (element.getAttribute(attrName) == attrVal) {
				arr[arr.length] = element;
			}
		}
		return arr;
	}

	function getElementsByClassName(className) {
		return document.getElementsByClassName(className);
	};

	function getElementsByTagAndClass(tag, className) {
		var s = className + ' ';
		var e = ' ' + className;
		var m = ' ' + className + ' ';
		var elements = getTags(tag);
		var arr = [],
		i,
		len = elements.length;
		for (i = 0; i < len; i++) {
			var element = elements[i];
			var cn = element.className;
			if ((cn == className) || startsWith(cn, s) || endsWith(cn, e) || contains(cn, m)) {
				arr[arr.length] = element;
			}
		}
		return arr;
	}

	function getChildrenByTagName(node, tagName) {
		var arr = [],
		i;
		if (node && node.childNodes) {
			var childNodes = node.childNodes;
			var len = childNodes.length;
			for (i = 0; i < len; i++) {
				var child = childNodes.item(i);
				if (child.tagName && (!tagName || (child.tagName.toUpperCase() == tagName.toUpperCase()))) {
					arr[arr.length] = child;
				}
				if (child.hasChildNodes()) {
					arr = arr.concat(getChildrenByTagName(child, tagName));
				}
			}
		}
		return arr;
	}

	function getChildrenByTagAndAttribute(node, tagName, attrName, attrVal) {
		var children = getChildrenByTagName(node, tagName);
		var arr = [],
		i,
		len = children.length;
		for (i = 0; i < len; i++) {
			var child = children[i];
			if (child.getAttribute(attrName) == attrVal) {
				arr[arr.length] = child;
			}
		}
		return arr;
	}

	function getChildrenByTagAndClass(node, tagName, className) {
		var s = className + ' ';
		var e = ' ' + className;
		var m = ' ' + className + ' ';
		var children = getChildrenByTagName(node, tagName);
		var arr = [],
		i,
		len = children.length;
		for (i = 0; i < len; i++) {
			var child = children[i];
			var cn = child.className;
			if ((cn == className) || startsWith(cn, s) || endsWith(cn, e) || contains(cn, m)) {
				arr[arr.length] = child;
			}
		}
		return arr;
	}

	function getDomainName(url) {
		if (startsWith(url, "http://")) {
			url = url.substring(7);
		} else if (startsWith(url, "https://")) {
			url = url.substring(8);
		} else if (startsWith(url, "ftp://")) {
			url = url.substring(6);
		}

		if (startsWith(url, "www.")) {
			url = url.substring(4);
		}

		var pos = url.indexOf('/');
		if (pos != -1) {
			url = url.substring(0, pos);
		}

		pos = url.indexOf(' ');
		if (pos != -1) {
			url = url.substring(0, pos);
		}

		return url;
	}

	function bigRandom() {
		var r1 = ('' + Math.random()).substring(2);
		var r2 = ('' + Math.random()).substring(2);
		return r1 + r2;
	}

	function getBoolPref(prefName) {
		var val = false;

		try {
			val = getBoolPreferenceValue(prefName);
		} catch (e) {}

		return val;
	}

	function getCharPref(prefName) {
		var val = null;

		try {
			val = getCharPreferenceValue(prefName);
		} catch (e) {}

		return val;
	}

	function getAllDisabled() {
		return getBoolPref('disabled');
	}

	function setAllDisabled(val) {
		var oldValue = getAllDisabled() ? 1 : 0;
		var newValue = val ? 1 : 0;
		var changed = (newValue != oldValue);

		if (changed) {
			setBoolPreferenceValue("disabled", val);
		}
	}

	function getShowRecsOnSRClick() {
		return getBoolPref("get_recs_on_sr_click");
	}

	function setShowRecsOnSRClick(val) {
		setBoolPreferenceValue("get_recs_on_sr_click", val);
	}

	function getMaxNumRecsForSRSelection() {
		return getCharPref("max_num_recs");
	}

	function setMaxNumRecsForSRSelection(val) {
		setCharPreferenceValue("max_num_recs", val);
	}

	function getInstId() {
		var instId = getCharPref("inst_id");
		instId = instId ? instId : setInstId(bigRandom());
		return instId;
	}

	function setInstId(value) {
		setCharPreferenceValue("inst_id", value);
		return value;
	}

	function getPartner() {
		var pc = getCharPref("partner_code");
		return pc ? pc : 'SC';
	}

	function setPartner(value) {
		setCharPreferenceValue("partner_code", value);
	}

	function getInstTimestamp() {
		var instTs = getCharPref("inst_timestamp");
		instTs = instTs ? instTs : setInstTimestamp(scGetTime());
		return instTs;
	}

	function setInstTimestamp(value) {
		value = value.toString();
		setCharPreferenceValue("inst_timestamp", value);
		return value;
	}

	function getDynamicPreferencesTimestamp() {
		return getCharPref("dynamic_preferences_timestamp");
	}

	function setDynamicPreferencesTimestamp(value) {
		setCharPreferenceValue("dynamic_preferences_timestamp", value);
	}

	function getLastSeenSplash() {
		return getCharPref("last_seen_splash");
	}

	function setLastSeenSplash(value) {
		setCharPreferenceValue("last_seen_splash", value);
	}

	function getGoogleSearchButtonClickTimestamp() {
		return getCharPref("google_search_button_click_ts");
	}

	function setGoogleSearchButtonClickTimestamp(value) {
		setCharPreferenceValue("google_search_button_click_ts", value);
	}

	function getGoogleSearchButtonClickQuery() {
		return getCharPref("google_search_button_click_query");
	}

	function setGoogleSearchButtonClickQuery(value) {
		setCharPreferenceValue("google_search_button_click_query", value);
	}

	function getSearchLinksEnabled() {
		return getBoolPref("search_links_enabled");
	}

	function setSearchLinksEnabled(val) {
		setBoolPreferenceValue("search_links_enabled", val);
	}

	function getServerSidePageLinksEnabled() {
		return getBoolPref("ss_page_links_enabled");
	}

	function setServerSidePageLinksEnabled(val) {
		setBoolPreferenceValue("ss_page_links_enabled", val);
	}

	function getRoamingSuggestionsEnabled() {
		return getBoolPref("roaming_suggestions_enabled");
	}

	function setRoamingSuggestionsEnabled(val) {
		setBoolPreferenceValue("roaming_suggestions_enabled", val);
	}

	function getOdometerDisabled() {
		return getBoolPref("odometer_disabled");
	}

	function setOdometerDisabled(val) {
		setBoolPreferenceValue("odometer_disabled", val);
	}

	function getCharPrefAsNum(name) {
		var num = 0;

		try {
			num = getCharPref(name);
			if (typeof num != 'number') {
				if (!num || (num.length === 0) || (num.charAt(0) < '0') || (num.charAt(0) > '9')) {
					num = 0;
				}
			}
		} catch (e) {}

		return num;
	}

	function incrementPref(name) {
		var num = 0;
		try {
			num = Number(getCharPrefAsNum(name));
		} catch (e) {}

		setCharPreferenceValue(name, num + 1);
	}

	function clearPref(name) {
		setCharPreferenceValue(name, 0);
	}

	function getNumSearches() {
		return getCharPrefAsNum("num_searches");
	}

	function incNumSearches() {
		if (!getOdometerDisabled()) {
			incrementPref("num_searches");
		}
	}

	function clearNumSearches() {
		clearPref("num_searches");
	}

	function getNumResultsClicked() {
		return getCharPrefAsNum("num_results_clicked");
	}

	function incNumResultsClicked() {
		if (!getOdometerDisabled()) {
			incrementPref("num_results_clicked");
		}
	}

	function clearNumResultsClicked() {
		clearPref("num_results_clicked");
	}

	function getNumResultsClickedWhenRecsAvailable() {
		return getCharPrefAsNum("num_results_clicked_when_recs_available");
	}

	function incNumResultsClickedWhenRecsAvailable() {
		if (!getOdometerDisabled()) {
			incrementPref("num_results_clicked_when_recs_available");
		}
	}

	function clearNumResultsClickedWhenRecsAvailable() {
		clearPref("num_results_clicked_when_recs_available");
	}

	function getNumRecsClicked() {
		return getCharPrefAsNum("num_recs_clicked");
	}

	function incNumRecsClicked() {
		if (!getOdometerDisabled()) {
			incrementPref("num_recs_clicked");
		}
	}

	function clearNumRecsClicked() {
		clearPref("num_recs_clicked");
	}

	function getSearchBoost() {
		var val = '-';

		var divisor = getNumResultsClickedWhenRecsAvailable();
		if (divisor > 0) {
			val = Math.round(getNumRecsClicked() / divisor * 100) + '%';
		}

		return val;
	}

	function getLangFromDomain(domain) {
		var lang;
		var ct = null;

		if (domain.length > 4) {
			if (domain.charAt(2) == '.') {
				ct = domain.substring(0, 2);
			} else if (domain.charAt(domain.length - 3) == '.') {
				ct = domain.substring(domain.length - 2);
			}
		}

		if (ct == 'mx' || ct == 'es' || ct == 'ar' || ct == 'cl' || ct == 'cr' || ct == 'pe' || ct == 'pr' || ct == 'uy' || ct == 'py' || ct == 'bo') {
			lang = 'es';
		} else if (ct == 'br' || ct == 'pt') {
			lang = 'pt';
		} else if (ct == 'de' || ct == 'at') {
			lang = 'de';
		} else if (ct == 'it' || ct == 'fr' || ct == 'nl' || ct == 'fi' || ct == 'no' || ct == 'ru' || ct == 'fi' || ct == 'hu' || ct == 'ro' || ct == 'tr') {
			lang = ct;
		} else if (ct == 'dk') {
			lang = 'da';
		} else if (ct == 'se') {
			lang = 'sv';
		} else {
			lang = 'en';
		}

		return lang;
	}

	// Creates a text area with which to decode a query
	// string found on the page or in URL parameters. S is
	// never remote HTML content so this operation should be
	// safe from XSS attacks.
	function decodeEntities(s) {
		var textarea = make("textarea");
		textarea.innerHTML = s;
		return textarea.value;
	}

	function removeChildren(element) {
		if (element && element.hasChildNodes()) {
			while (element.childNodes.length >= 1) {
				element.removeChild(element.firstChild);
			}
		}
	}

	function removeSimpleHtmlTags(s, retainImageTags) {
		var openImgTag = retainImageTags ? '<img' : null;
		var closeImgTag = retainImageTags ? '</img' : null;

		if (s) {
			var output = '',
			i;
			var len = s.length;
			var inTag = false;
			for (i = 0; i < len; i++) {
				var c = s.charAt(i);

				if (!inTag && (c == '<') && (s.substr(i, 4) != openImgTag) && (s.substr(i, 5) != closeImgTag)) {
					inTag = true;
				} else if (inTag && (c == '>')) {
					inTag = false;
				} else if (!inTag) {
					output += c;
				}
			}
			return output;
		} else {
			return s;
		}
	}

	function getNumResultsPerPage() {
		var num = 10,
		i;

		var cookieParts = document.cookie.split('; ');
		for (i = 0; i < cookieParts.length; i++) {
			var cookiePart = cookieParts[i];
			var pos = cookiePart.indexOf(SC.numResultsToken);
			if (pos > 0) {
				num = parseInt(cookiePart.substring(pos + SC.numResultsToken.length));
				break;
			}
		}

		return num;
	}

	function inNewWindowMode() {
		var inNewWindowMode = false;
		if ((typeof SC.cookieNewWindowToken != 'undefined') && SC.cookieNewWindowToken) {
			var cookieParts = document.cookie.split('; ');
			var i;
			for (i = 0; i < cookieParts.length; i++) {
				var cookiePart = cookieParts[i];
				var containsToken = contains(cookiePart, SC.cookieNewWindowToken);
				if (containsToken) {
					inNewWindowMode = true;
					break;
				}
			}
		}

		return inNewWindowMode;
	}

	function linkClickOpensNewWindow(event) {
		return (event.shiftKey || event.ctrlKey || event.metaKey) ? true : inNewWindowMode();
	}

	function getPageUrl() {
		// make a new copy of window.location
		return '' + window.location;
	}

	function getSSMapKey() {
		return getUrlHash(SC.currentDomain + SC.query);
	}

	function searchEngineQueryURL(query, numToGet, startNum) {
		var domain = SC.currentDomain;
		if (startsWith(domain, 'encrypted.')) {
			domain = domain.replace('encrypted.', 'www.');
		}
		var url = window.location.protocol + '//' + domain;

		var loc = scIsFF ? window.top.location : window.location;
		var argsString = loc.search.substring(1);

		// google search string comes from a link, so it's already encoded
		if (!onGoogleSerp()) {
			query = encodeURIComponent(query);
		}

		url += ('/' + SC.searchQueryCommand + '?' + SC.searchQueryTermArgName + '=' + query);
		if (SC.searchQueryNumResultsArgName) {
			url += ('&' + SC.searchQueryNumResultsArgName + '=' + numToGet);
		}
		if (SC.searchQueryStartResultArgName) {
			url += ('&' + SC.searchQueryStartResultArgName + '=' + startNum);
		}

		if (onGoogleSerp()) {
			var args = argsString.split('&');
			var i;
			for (i = 0; i < args.length; i++) {
				var arg = args[i];
				var sepPos = arg.indexOf('=');
				if (sepPos != -1) {
					var name = arg.substring(0, sepPos);
					var value = arg.substring(sepPos + 1);
					if (name != SC.searchQueryTermArgName &&
						name != SC.searchQueryNumResultsArgName &&
						name != SC.searchQueryStartResultArgName) {
						url = url + '&' + name + '=' + value;
					}
				} else {
					url = url + '&' + arg;
				}
			}
		}

		if (onGoogleSerp()) {
			var amp = endsWith(url, '&') ? '' : '&';
			url = url + amp + 'as_qdr=all';
		}
		return url;
	}

	function uploadSRs(searchTerm) {
		if (SC.uploadResults && SC.numSRsForInitialUpload) {
			var startNum = (SC.batchNum - 1) * SC.batchSize;
			var query = searchTerm || SC.query;
			var url = searchEngineQueryURL(query, SC.batchSize, startNum);
			sc_ajax({
				method : 'GET',
				url : url,
				onload : function (xhr) {
					var html = getResponseText(xhr);
					if (SC.query == query) { // could differ due to Google Instant

						if (html.match(/<html/i) || html.match(/<!doctype html/i)) {
							doUploadSRs(html, query);
						} else {
							handleConnectionError('uploadSRs1', url);
						}
					}
				},
				onerror : function (xhr) {
					handleConnectionError('uploadSRs2', url);
				}
			});
		}
	}

	function doUploadSRs(html, query) {
		html = pruneHtml(html);

		var url = SC.host + 'search/upload';
		sc_ajax({
			method : 'POST',
			url : url,
			headers : {
				'Content-type' : 'application/x-www-form-urlencoded'
			},
			data : 'ssMapKey=' + getSSMapKey() +
			'&instId=' + SC.instId +
			'&extensionVersion=' + SC.extensionVersion +
			'&srPayloadHtml=' + encodeURIComponent(html),
			onload : function (xhr) {
				var text = getResponseText(xhr);
				if (isOkServerResponse(text)) {
					var xmlRoot = scXmlParser(text);
					var data = xmlRoot.getElementsByTagName('data')[0];
					if (data) {
						if (!SC.firstBatchReceived) {
							SC.firstBatchReceived = true;

							var node = data.getElementsByTagName('moreResultsAvailable')[0];
							if (scGetText(node) != '1') {
								removeMoreResultsLinks();
							}

							node = data.getElementsByTagName('notEnoughResults')[0];
							if (scGetText(node) == '1') {
								handleConnectionError('doUploadSRs1', null);
							}
						}

						if (SC.bufferedEvent) {
							clickHandler(SC.bufferedEvent);
							SC.bufferedEvent = null;
						}
						SC.numBatchesLeftToUpload--;
						if (SC.numBatchesLeftToUpload > 0) {
							SC.batchNum++;
							uploadSRs(query);
						}
					}
				} else {
					if (SC.batchNum == 1) {
						handleConnectionError('doUploadSRs2', url);
					}
				}
			},
			onerror : function () {
				if (SC.batchNum == 1) {
					handleConnectionError('doUploadSRs3', url);
				}
			}
		});
	}

	function uploadMoreSRs() {
		if (SC.uploadResults && ((SC.batchNum + 1) * SC.batchSize <= SC.maxSRsToUpload)) {
			SC.batchNum++;
			uploadSRs();
		}
	}

	function doGetSRByUrlHash(urlHash) {
		var list = getChildrenByTagAndAttribute(document.body, null, 'scUrlHash', urlHash);
		return (list.length > 0) ? list[0] : null;
	}

	function getSRByUrlHash(urlHash) {
		if (startsWith(urlHash, 'www')) {
			urlHash = urlHash.substring(3);
		}

		var srNode = doGetSRByUrlHash(urlHash);
		if (!srNode) {
			srNode = doGetSRByUrlHash('www' + urlHash);
		}

		return srNode;
	}

	function getRecsSpan(urlHash) {
		var span = getById('scRecs' + urlHash);
		if (!span) {
			if (startsWith(urlHash, 'www')) {
				urlHash = urlHash.substring(3);
				span = getById('scRecs' + urlHash);
			} else {
				span = getById('scRecswww' + urlHash);
			}
		}
		return span;
	}

	function updateRecsInUI(urlHash, recs, data, updateAttrs) {
		var span = getRecsSpan(urlHash);
		if (recs) {
			if (span && span.getAttribute('scIsOrganicResult')) {
				var recsHtml = "<table style='clear: both;'>" + scGetText(recs) + "</table>";

				appendSafeHtml(recsHtml, function(html) {
					span.innerHTML = html;
					if (updateAttrs) {
						updateAttributesAfterUi(data);
					}
				});
			}

			installSCClickHandlers(span);
		}
	}

	function updateAttributesAfterUi(data) {
		if (scIsFF) {
			var metaTags = data.getElementsByTagName('srsMetaData');
			var recs = [];

			for (var n = 0; n < metaTags.length; n++) {
				recs = metaTags[n].getElementsByTagName('rec');

				for (var i = 0; i < recs.length; i++) {
					var rec = recs[i];
					try {
						var urlHash = scGetText(rec.getElementsByTagName('urlHash')[0]);
						var isOrganic = scGetText(rec.getElementsByTagName('isOrganic')[0]);
						var srType = scGetText(rec.getElementsByTagName('srType')[0]);

						var node = getById(urlHash);
						if (!node || node.getAttribute('scAttrsUpdated')) {
							continue;
						}

						node.setAttribute('scUrlHash', urlHash);
						node.setAttribute('scAttrsUpdated', '1');

						if (isOrganic === '1') {
							node.setAttribute('scIsOrganicResult', isOrganic);
						}

						node = getRecsSpan(urlHash);
						if (node) {
							node.setAttribute('scIsOrganicResult', isOrganic);
							node.setAttribute('srType', srType);
						}

					} catch (e7) {
						logger.debug(e7.message);
					}
				}

			}
		}
	}

	function updateUIAfterSelection(data, displayRecs, urlHash, gesture) {
		if (displayRecs && !getAllDisabled()) {
			var srNode = getSRByUrlHash(urlHash);
			var recs = data.getElementsByTagName('recs')[0];
			if (srNode) {
				updateRecsInUI(urlHash, recs, data, true);
			} else {
			}
		}
	}

	var refinedQueries = {};
	function runAugmentedQuery(data) {
		SC.numBatchesLeftToUpload += 3;
		var augmentedQuery = scGetText(data.getElementsByTagName('refinedQuery')[0]);
		if (augmentedQuery && !refinedQueries[augmentedQuery]) {
			refinedQueries[augmentedQuery] = 1;
			uploadSRs(augmentedQuery);
		}
	}

	function getRecs(urlHash, displayRecs, gesture, openNewWindow) {
		if (SC.gettingRecs || getAllDisabled()) {
			return;
		}

		SC.gettingRecs = true;

		var maxNumRecs = ((gesture == 'click' || gesture == 'rightClick') && !getShowRecsOnSRClick()) ? 0 : getMaxNumRecsForSRSelection();
		var url = SC.host + 'search/selectSearchResult?ssMapKey=' + getSSMapKey() + '&instId=' + SC.instId + '&extensionVersion=' + SC.extensionVersion + '&gesture=' + gesture + '&maxNumRecs=' + maxNumRecs + '&urlHash=' + urlHash + '&openNewWindow=' + (openNewWindow ? '1' : '0');
		sc_ajax({
			method : 'GET',
			url : url,
			onload : function (xhr) {
				try {
					var text = getResponseText(xhr);
					if (isOkServerResponse(text)) {
						var xmlRoot = scXmlParser(text);
						var data = xmlRoot.getElementsByTagName('data')[0];

						if (data) {
							updateUIAfterSelection(data, displayRecs, urlHash, gesture);

							runAugmentedQuery(data);

							SC.srSelectionCount++;
							if (SC.srSelectionCount === 3) {
								SC.srSelectionCount = 0;
								uploadMoreSRs();
							}
						}
					}
				} catch (e) {
				}
				finally {
					SC.gettingRecs = false;
				}
			},
			onerror : function () {
				SC.gettingRecs = false;
				handleConnectionError('getRecs', url);
			}
		});
	}

	function closeRecs(urlHash) {
		sc_ajax({
			method : 'GET',
			url : SC.host + 'search/closeRecs?ssMapKey=' + getSSMapKey() + '&instId=' + SC.instId + '&extensionVersion=' + SC.extensionVersion + '&urlHash=' + urlHash
		});

		var span = getRecsSpan(urlHash);
		removeChildren(span);
	}

	function removeMoreResultsLinks() {
		var aTags = getElementsByTagAndClass("a", "scMoreResults");
		var i;
		for (i = 0; i < aTags.length; i++) {
			try {
				var aTag = aTags[i];
				aTag.parentNode.removeChild(aTag);
			} catch (e) {
			}
		}
	}

	function insertMoreResults(text) {
		var insertPoint = getById('scInsertPoint');

		if (scIsFF) {
			var xmlRoot = scXmlParser(text);
			var data = xmlRoot.getElementsByTagName('data')[0];
			text = scGetText(data.getElementsByTagName('recs')[0]);
		}

		appendSafeHtml(text, function(html) {
			insertPoint.innerHTML = html;
			updateAttributesAfterUi(data);
		});

		installSCClickHandlers(insertPoint);

		if (scIsOldIE) {
			insertPoint.scrollIntoView();
		}

		insertPoint.id = '';
	}

	function duplicatePageReceivedFromServer(text) {
		var pageNum;
		for (pageNum = 99; pageNum >= 0; pageNum--) {
			var nodeId = 'scPageSeparator' + pageNum;
			if (getById(nodeId)) {
				if (text.indexOf(nodeId) >= 0) {
					return true;
				}
				break;
			}
		}

		return false;
	}

	function moreResults() {
		if (SC.gettingMoreResults) {
			return;
		}

		SC.gettingMoreResults = true;
		if (getById('scInsertPoint')) {
			var url = SC.host + 'search/moreResults?ssMapKey=' + getSSMapKey() + '&instId=' + SC.instId + '&extensionVersion=' + SC.extensionVersion + '&now=' + scGetTime();
			sc_ajax({
				method : 'GET',
				url : url,
				onload : function (xhr) {
					try {
						var text = getResponseText(xhr);
						if (isOkServerResponse(text)) {
							if ((text.length > 10) && !duplicatePageReceivedFromServer(text)) {
								insertMoreResults(text);

								SC.srSelectionCount = 0;
								uploadMoreSRs();

								if (contains(text, '<!--NO_MORE_RESULTS-->')) {
									removeMoreResultsLinks();
								}

								var pageNum;
								for (pageNum = 99; pageNum >= 0; pageNum--) {
									var nodeId = 'scPageSeparator' + pageNum;
									if (getById(nodeId)) {
										focusOnNode(nodeId);
										break;
									}
								}
							}
						} else {
							handleConnectionError('moreResults1', url);
						}
					} catch (e) {
					}
					finally {
						SC.gettingMoreResults = false;
					}
				},
				onerror : function () {
					SC.gettingMoreResults = false;
					handleConnectionError('moreResults2', url);
				}
			});
		}
	}

	function goToPage(start) {
		if (SC.goingToPage) {
			return;
		}

		SC.goingToPage = true;
		if (getById('scInsertPoint')) {
			var url = SC.host + 'search/goToPage?ssMapKey=' + getSSMapKey() + '&instId=' + SC.instId + '&extensionVersion=' + SC.extensionVersion + '&start=' + start + '&now=' + scGetTime();
			sc_ajax({
				method : 'GET',
				url : url,
				onload : function (xhr) {
					try {
						var text = getResponseText(xhr);
						if (isOkServerResponse(text)) {
							if ((text.length > 10) && !duplicatePageReceivedFromServer(text)) {
								var newPageNum = Math.round(start / getNumResultsPerPage()) + 1;
								insertMoreResults(text);

								SC.srSelectionCount = 0;
								uploadMoreSRs();

								focusOnNode('scPageSeparator' + newPageNum);
							}
						} else {
							handleConnectionError('goToPage1', url);
						}
					} catch (e) {
					}
					finally {
						SC.goingToPage = false;
					}
				},
				onerror : function () {
					SC.goingToPage = false;
					handleConnectionError('goToPage2', url);
				}
			});
		}
	}

	function isSecondGoogleSearchButtonClick() {
		var now = scGetTime();
		var ts = getGoogleSearchButtonClickTimestamp();
		var query = getGoogleSearchButtonClickQuery();
		var rtn = false;
		if (!ts) {
			setGoogleSearchButtonClickTimestamp(now);
			setGoogleSearchButtonClickQuery(SC.query);
		} else {
			var diff = now - ts;
			if (diff > 99) {
				setGoogleSearchButtonClickTimestamp(now);
				setGoogleSearchButtonClickQuery(SC.query);
				rtn = (query == SC.query);
			}
		}

		return rtn;
	}

	function resetSearchSessionAndResetPage() {
		sc_ajax({
			method : 'GET',
			url : SC.host + 'search/reset?ssMapKey=' + getSSMapKey() + '&instId=' + SC.instId + '&extensionVersion=' + SC.extensionVersion,
			onload : function (xhr) {
				SC.forceReinvokeExtensionInit = true;
				resetPage();
			},
			onerror : function () {
				SC.forceReinvokeExtensionInit = true;
				resetPage();
			}
		});
	}

	function resetPage() {
		SC.srSelectionCount = 0;
		var i;

		for (i = 0; i < scSRNodes.length; i++) {
			var srNode = scSRNodes[i];
			var url = SERP.extractUrlFromSRNode(srNode);
			if (url) {
				var urlHash = getUrlHash(url);
				var span = getRecsSpan(urlHash);
				removeChildren(span);
			}
		}

		var originalInsertPoint = getElementsByTagAndAttribute("div", "scOriginalInsertPoint", "1")[0];
		removeChildren(originalInsertPoint);
		originalInsertPoint.setAttribute('id', 'scInsertPoint');
	}

	function getUrlHashFromNode(node) {
		var urlHash;
		while (node && node.getAttribute) {
			if (!urlHash) {
				urlHash = node.getAttribute('scUrlHash');
			}

			node = node.parentNode;
		}

		return urlHash;
	}

	function closeRecsClickHandler(event) {
		try {
			cancelEvent(event);
			var node = scIsIE ? event.srcElement : event.target;

			var urlHash = getUrlHashFromNode(node);
			closeRecs(urlHash);
		} catch (e) {
		}
	}

	function installSCClickHandler(node, func) {
		if (!node) {
			node = document;
		}

		if (!func && onSerpThatSupportsReranking()) {
			func = clickHandler;
			if (scIsOldIE) {
				onmouseup = function () {
					clickHandler(window.event);
				};
			}
		}

		if (node && func) {
			// use a hash code to prevent the same handler being installed
			// more than once on the same node
			var hashCode = node.nodeName + node.nodeType + func.toString().length;
			if (!SC.clickHandlers[hashCode]) {
				SC.clickHandlers[hashCode] = 1;
				if (scIsOldIE) {
					node.attachEvent('onmouseup', func);
				} else {
					node.addEventListener('click', func, true);
				}
			}
		}
	}

	function uninstallSCClickHandler(node, func) {
		if (!node) {
			node = document;
		}

		if (!func && onSerpThatSupportsReranking()) {
			func = clickHandler;
			if (scIsOldIE) {
				onmouseup = function () {};
			}
		}

		if (node && func) {
			// use a hash code to prevent the same handler being installed
			// more than once on the same node
			var hashCode = node.nodeName + node.nodeType + func.toString().length;
			if (SC.clickHandlers[hashCode]) {
				SC.clickHandlers[hashCode] = 0;
				if (scIsOldIE) {
					node.detachEvent('onmouseup', func);
				} else {
					node.removeEventListener('click', func, true);
				}
			}
		}
	}

	function installSCClickHandlers(node) {
		var imgs = getElementsByTagAndClass("img", "scClose");
		var i,
		len = imgs.length;
		for (i = 0; i < len; i++) {
			installSCClickHandler(imgs[i], closeRecsClickHandler);
		}
	}

	function clickHandler(event) {
		try {
			if (!onSerpThatSupportsReranking()) {
				return;
			}

			var ready = true;
			if (SC.uploadResults && (!SC.firstBatchReceived && !SC.continuingSession)) {
				SC.bufferedEvent = scIsIE ? new EventRecord(event) : event;
				ready = false;
			}

			var node = scIsIE ? event.srcElement : event.target;

			var parentNode = node.parentNode;
			var tagName = node.tagName;
			if (!tagName) {
				tagName = node.getAttribute('tagName');
			}
			var className = node.className;
			if (!className) {
				className = node.getAttribute('class');
			}

			var rightClick;
			if (event.which) {
				rightClick = (event.which === 3);
			} else if (event.button) {
				rightClick = (event.button === 2);
			}

			if (className) {
				if (className == 'scMoreResults') {
					moreResults();
					cancelEvent(event);
					return;
				}
			}

			var isGoogleSearchButton = onGoogleSerp() && (tagName == 'INPUT') && (className == 'lsb');
			if (isGoogleSearchButton) {
				if (isSecondGoogleSearchButtonClick()) {
					resetSearchSessionAndResetPage();
				} else {
					SC.forceReinvokeExtensionInit = true;
				}
				return;
			}

			var url;
			var urlHash;
			var isInLink = false;
			var aTagNode;
			var isNextPageLink = false;
			var gotoPageStartVal = 0;
			while (node && node.getAttribute) {
				if (!isInLink) {
					var text = node.toString();
					isInLink = (startsWith(text, 'http') || startsWith(text, 'ftp'));
					if (isInLink) {
						url = text;
					}
				}

				var id = '';
				try {
					id = node.getAttribute('id');
				} catch (e) {
				}

				if (!urlHash) {
					urlHash = node.getAttribute('scUrlHash');
				}

				if (!(isNextPageLink || gotoPageStartVal) && (node.tagName == 'A')) {
					try {
						var linkType = determineLinkType(node);
						if (linkType == 'Next') {
							isNextPageLink = true;
						} else if (linkType == 'Goto') {
							gotoPageStartVal = node.getAttribute('scGotoPageStartVal');
						}
					} catch (e) {
					}
					aTagNode = node;
				}

				node = node.parentNode;
			}

			if (isNextPageLink) {
				cancelEvent(event);
				if (ready) {
					moreResults();
					SC.numUserActions++;
				}
				return;
			} else if (gotoPageStartVal) {
				cancelEvent(event);
				if (ready) {
					goToPage(gotoPageStartVal);
					SC.numUserActions++;
				}
				return;
			}

			var clickedLink = (tagName == 'A' || isInLink);
			var clickedLinkFromSerp = clickedLink && SC.searchEngine;
			var openNewWindow = linkClickOpensNewWindow(event);
			if (urlHash) {
				if (clickedLinkFromSerp) {
					getRecs(urlHash, ready && (rightClick || openNewWindow), rightClick ? 'rightClick' : 'click', openNewWindow);
					var span = getRecsSpan(urlHash);
					if (span) {
						incNumResultsClicked();

						if (SC.numUserActions > 0) {
							incNumResultsClickedWhenRecsAvailable();
						}
						SC.numUserActions++;

						if (span.getAttribute('srType') == 'rec') {
							incNumRecsClicked();
						}
					}
				}
			} else if (clickedLinkFromSerp && url) {
				sc_ajax({
					method : 'GET',
					url : SC.host + 'search/linkClick?ssMapKey=' + getSSMapKey() + '&instId=' + SC.instId + '&extensionVersion=' + SC.extensionVersion + '&url=' + encodeURIComponent(url) + '&openNewWindow=' + (openNewWindow ? '1' : '0')
				});
			}
		} catch (e) {
		}
	}

	function removeProtocol(url) {
		var pos = url.indexOf('://');
		if (pos != -1) {
			url = url.substring(pos + 3);
		}
		return url;
	}

	function getUrlHash(url) {
		var urlHash = '';

		if (url) {
			url = decodeEntities(url);

			var len = url.length,
			i;
			for (i = 0; i < len; i++) {
				var c = url.charAt(i);
				if ((c >= 'a' && c <= 'z') || (c >= 'A' && c <= 'Z') || (c >= '0' && c <= '9') || (c == '-') || (c == '_')) {
					urlHash += c;
				}
			}
		}
		return urlHash;
	}

	function handleConnectionError(where, url) {
		logger.log('error in ' + where);
		var navbar = getNavbar();

		var nodes = getChildrenByTagName(navbar, 'a');
		var i;
		for (i = 0; i < nodes.length; i++) {
			restoreHref(nodes[i]);
		}

		if (scIsOldIE) {
			document.detachEvent('onmouseup');
		} else {
			document.removeEventListener('click', clickHandler, true);
		}
	}

	function focusOnNode(id) {
		var nodeToFocus = getById(id);
		if (nodeToFocus) {
			nodeToFocus.scrollIntoView();
		}
	}

	function insertRecsSpans(isGoogle) {
		var srContainer,
		i;
		for (i = 0; i < scSRNodes.length; i++) {
			try {
				var srNode = scSRNodes[i];
				var url = SERP.extractUrlFromSRNode(srNode);
				var attrVal = srNode.getAttribute('scUrlHash');
				var isGoogleStarSection = isGoogle && contains(srNode.innerHTML, 'href="/bookmarks/find?');
				if (url && !attrVal && !isGoogleStarSection) {
					var urlHash = getUrlHash(url);
					srNode.setAttribute('scUrlHash', urlHash);

					var recsSpan = make('span');
					recsSpan.setAttribute('id', 'scRecs' + urlHash);
					recsSpan.setAttribute('scIsOrganicResult', 1);
					srNode.appendChild(recsSpan);

					if (!srContainer) {
						srContainer = isGoogle ? srNode.parentNode.parentNode : srNode.parentNode;
					}
				}
			} catch (e) {
			}
		}
		return srContainer;
	}

	function initUI() {
		var isGoogle = onGoogleSerp();

		var srContainer = insertRecsSpans(isGoogle);
		if (srContainer) {
			var div = make('div');
			div.setAttribute('id', 'scInsertPoint');
			div.setAttribute('scOriginalInsertPoint', '1');
			srContainer.appendChild(div);
		}

		if (!getAllDisabled()) {
			interceptMoreResultsLinks();
		}

		if (isGoogle) {
			// prevent recs from bleeding into east content
			addPageStyle('h3.r { white-space: normal !important; word-break: hyphenate; } #res h3.r { white-space: normal !important; word-break: hyphenate; }');
		}
	}

	function updateUIAfterRefresh(data) {
		if (getAllDisabled()) {
			return;
		}
		initUI();

		var srXmlNodes = data.getElementsByTagName('sr');
		var i;
		for (i = 0; i < srXmlNodes.length; i++) {
			var srXmlNode = srXmlNodes[i];
			var urlHash = scGetText(srXmlNode.getElementsByTagName('urlHash')[0]);
			var srNode = getSRByUrlHash(urlHash);
			if (srNode) {
				var recs = srXmlNode.getElementsByTagName('recsHtml')[0];
				var updateAttrs = (i == (srXmlNodes.length - 1));
				updateRecsInUI(urlHash, recs, data, updateAttrs);
			}
		}

		var moreResultsHtml = scGetText(data.getElementsByTagName('moreResults')[0]);
		var originalInsertPoint = getElementsByTagAndAttribute("div", "scOriginalInsertPoint", "1")[0];
		if (moreResultsHtml && originalInsertPoint) {

			appendSafeHtml(moreResultsHtml, function(html) {
				originalInsertPoint.innerHTML = html;
				originalInsertPoint.id = '';
				updateAttributesAfterUi(data);
			});

		}

		if (!scIsFF) {
			focusOnNode("scFocus");
		}


	}

	function refreshDynamicContent() {
		if (SC.refreshingDynamicContent || getAllDisabled()) {
			return;
		}

		SC.refreshingDynamicContent = true;
		var url = SC.host + 'search/refresh?ssMapKey=' + getSSMapKey() + '&instId=' + SC.instId + '&extensionVersion=' + SC.extensionVersion;
		sc_ajax({
			method : 'GET',
			url : url,
			onload : function (xhr) {
				try {
					var text = getResponseText(xhr);
					if (isOkServerResponse(text)) {
						var xmlRoot = scXmlParser(text);
						var data = xmlRoot.getElementsByTagName('data')[0];
						if (data) {
							var userStatusNode = data.getElementsByTagName('userStatus')[0];
							scUserStatus = userStatusNode ? scGetText(userStatusNode) : "";

							node = data.getElementsByTagName('notEnoughResults')[0];
							if (scGetText(node) != '1') {
								updateUIAfterRefresh(data);
							}
						}
					} else {
						handleConnectionError('refresh1', url);
					}
				} catch (e) {
				}
				finally {
					SC.refreshingDynamicContent = false;
				}
			},
			onerror : function () {
				SC.refreshingDynamicContent = false;
				handleConnectionError('refresh2', url);
			}
		});
	}

	function pageshowHandler(event) {
		if ((typeof event !== "undefined") && (typeof event.persisted !== "undefined") && event.persisted) {
			installSCClickHandler();
			refreshDynamicContent();
		}
	}

	function pagehideHandler(event) {
		if ((typeof event !== "undefined") && (typeof event.persisted !== "undefined") && event.persisted) {
			uninstallSCClickHandler();
		}
	}

	function customizePageKeyHandler(event) {
		if (event.keyCode == 116) {
			event.keyCode = 0;
			event.returnValue = false;
			updateCustomizePage();
		}
	}

	function customizePageClickHandler(event) {
		try {
			var node = scIsIE ? event.srcElement : event.target;
			var id = node.getAttribute('id');
			if (startsWith(id, 'save')) {
				saveCustomizePage();
			} else {
				switch (id) {
				case 'disableOdometer':
					setOdometerDisabled(true);
					updateCustomizePage();
					break;
				case 'enableOdometer':
					setOdometerDisabled(false);
					updateCustomizePage();
					break;
				case 'resetOdometer':
					clearNumSearches();
					clearNumResultsClicked();
					clearNumResultsClickedWhenRecsAvailable();
					clearNumRecsClicked();
					updateCustomizePage();
					break;
				}
			}
		} catch (e) {
		}
	}

	function setCustomizePageCheckbox(divName, val) {
		try {
			getById(divName).checked = val;
		} catch (e) {
		}
	}

	function updateCustomizePage() {
		try {
			var checkboxes = getElementsByTagAndAttribute("input", "type", "checkbox");
			for (i = 0; i < checkboxes.length; i++) {
				checkboxes[i].checked = false;
			}

			setCustomizePageCheckbox('enableAll', !getAllDisabled());

			setCustomizePageCheckbox('showRecsOnSRClick', getShowRecsOnSRClick());
			getById('maxRecs').value = getMaxNumRecsForSRSelection();
			setCustomizePageCheckbox('addSearchLinks', getSearchLinksEnabled());
			setCustomizePageCheckbox('addRoamingSuggestions', getRoamingSuggestionsEnabled());

			getById('odometerNumSearches').textContent = getNumSearches();
			getById('odometerNumResultsClicked').textContent = getNumResultsClicked();
			getById('odometerNumResultsClickedWhenRecsAvailable').textContent = getNumResultsClickedWhenRecsAvailable();
			getById('odometerNumRecsClicked').textContent = getNumRecsClicked();
			getById('odometerSearchBoost').textContent = getSearchBoost();

			if (getOdometerDisabled()) {
				getById('disableOdometer').style.display = 'none';
				getById('enableOdometer').style.display = 'block';
			} else {
				getById('disableOdometer').style.display = 'block';
				getById('enableOdometer').style.display = 'none';
			}

			if (SC.partner.toLowerCase() == 'yhoo') {
				removeChildren(getById('other'));

			}
		} catch (e) {
		}
	}

	function isCheckedOnCustomizePage(divName) {
		var b;
		try {
			b = getById(divName).checked;
		} catch (e) {
		}
		return b;
	}

	function saveCustomizePage() {
		setAllDisabled(!isCheckedOnCustomizePage('enableAll'));

		setShowRecsOnSRClick(isCheckedOnCustomizePage('showRecsOnSRClick'));
		setMaxNumRecsForSRSelection(getById('maxRecs').value);
		setSearchLinksEnabled(isCheckedOnCustomizePage('addSearchLinks'));
		setRoamingSuggestionsEnabled(isCheckedOnCustomizePage('addRoamingSuggestions'));

		alert('Your preferences have been saved.');
	}

	function updateDynamicPreferences() {
		if (getAllDisabled()) {
			return;
		}

		var now = scGetTime();
		var timestamp = getDynamicPreferencesTimestamp() || 0;
		var checkInterval = 24 * 60 * 60 * 1000; // one day
		if (now - timestamp > checkInterval) {
			setDynamicPreferencesTimestamp(now);
			sc_ajax({
				method : 'GET',
				url : SC.host + 'dynamic_preferences.jsp',
				onload : function (xhr) {
					var text = getResponseText(xhr);
					if (isOkServerResponse(text)) {
						var xmlRoot = scXmlParser(text);
						var settings = xmlRoot.getElementsByTagName('settings')[0];
						processDynamicPreferencesSettings(settings);
					}
				}
			});
		}
	}

	function processDynamicPreferencesSettings(settings) {
		try {
			var nodes = settings.getElementsByTagName('setting');
			var i;
			for (i = 0; i < nodes.length; i++) {
				var setting = nodes[i];
				processSetting(setting);
			}
		} catch (e) {
		}
	}

	function processSetting(setting) {
		var setpref = setting.getElementsByTagName('setpref')[0];
		var prefName = setpref.getAttribute('name');

		var isMatch = allConditionsMet(setting);
		if (isMatch) {
			var matchValue = setpref.getAttribute('matchvalue');
			setDynamicPreference(prefName, matchValue);
		} else {
			var nomatchValue = setpref.getAttribute('nomatchvalue');
			setDynamicPreference(prefName, nomatchValue);
		}
	}

	function setDynamicPreference(prefName, value) {
		try {
			if (value === '0' || value === 'false') {
				setBoolPreferenceValue(prefName, false);
			} else if (value === '1' || value === 'true') {
				setBoolPreferenceValue(prefName, true);
			} else if ((value !== null) && (value !== undefined)) {
				setCharPreferenceValue(prefName, value);
			}
		} catch (e) {
		}
	}

	function allConditionsMet(setting) {
		var nodes = setting.getElementsByTagName('condition');
		var i;
		for (i = 0; i < nodes.length; i++) {
			var condition = nodes[i];
			var value = getConditionValue(condition);
			var regex = condition.getAttribute('regex');
			if (!(new RegExp(regex, 'i')).test(value)) {
				return false;
			}
		}

		return true;
	}

	function getConditionValue(condition) {
		var value = '';

		var src = condition.getAttribute('src');
		if (src === 'extension_version') {
			value = SC.extensionVersion;
		} else if (src === 'user_agent') {
			value = getUserAgent();
		} else {
			value = getCharPref(src);
		}

		// convert value to a string
		if (!value) { // handle value === null, undefined or false
			value = '';
		} else if (value === true) {
			value = 'true';
		}

		var end = condition.getAttribute('end');
		if (end) {
			value = value.substring(0, end);
		}

		var start = condition.getAttribute('start');
		if (start) {
			value = value.substring(start);
		}

		return value;
	}

	function onGoogleSerp() {
		var args = window.location.search;
		var path = window.location.pathname;
		var isGoogleSearchDomain = (contains(SC.currentDomain, '.google.') && (contains(SC.currentDomain, 'www') || contains(SC.currentDomain, 'encrypted')));
		var onSerp = (isGoogleSearchDomain && ((path == '/') || (path == '/search') || (path == '/webhp')) && !contains(args, 'define%3A') && !contains(args, '&tbs=frim'));
		return onSerp;
	}

	function onSerpThatSupportsReranking() {
		return onGoogleSerp();
	}

	function onSCWebSitePage(bodyId) {
		var b = false;

		if (onSCPage()) {
			try {
				b = (document.body.id == bodyId);
			} catch (e) {
			}
		}

		return b;
	}

	function searchLinksTermList() {
		var terms = ['airline', 'accident attorney', 'annuity settlement', 'apparel', 'auto donation', 'auto title loan', 'bipolar', 'blu-ray', 'business bank account', 'camcorder', 'camera', 'clothes', 'clothing', 'conference call service', 'consolidating debt', 'cosmetic', 'coupon', 'data room', 'dedicated hosting', 'depression', 'digital marketing course', 'digital marketing degree', 'dvd', 'electronics', 'erectile dysfunction', 'flight', 'footwear', 'fragrance', 'gaming system', 'halo', 'hdtv', 'home alarm', 'home theater', 'imac', 'injury attorney', 'insomnia', 'insurance quotes', 'ipad', 'iphone', 'ipod', 'jailbreak', 'jeans', 'kindle', 'kinect', 'laptop', 'lenovo', 'levitra', 'lipitor', 'macbook', 'medical billing software', 'mortgage', 'netbook', 'nintendo ds', 'nintendo dsi', 'online college', 'online forex broker', 'online gold trading', 'online marketing course', 'online marketing degree', 'paralegal training', 'perfume', 'pet med', 'playstation 3', 'ps3', 'refinance', 'reverse mortgage lender', 'ringtone', 'server monitoring software', 'shoe', 'slr', 'software asset management', 'tadalafil', 'tax attorney', 'tax debt relief', 'tax help', 'tax levy', 'telemarketing software', 'transfer credit card', 'video game', 'video hosting', 'web design training', 'webcam', 'webpage monitoring', 'wii', 'xbox'];
		return terms;
	}

	function clientSideSearchLinks() {
		scSearchLinksInvocationTimestamp = scGetTime();

		try {
			var terms = searchLinksTermList();

			var textNodes = [];
			addTextNodesToArray(document.body, textNodes);
			addSearchLinks(terms, textNodes, 'c');
		} catch (e) {
		logger.debug(e.message);
		}

		if (onFacebookPage()) {
			setTimeout(function () {
				clientSideSearchLinks();
			}, 10000);
		}
	}

	function addToArrayWithNoDups(arr, item) {
		var i = arr.length;
		while (i--) {
			if (arr[i] === item) {
				return;
			}
		}
		arr.push(item);
	}

	function addTextNodesToArray(node, arr) {
		if (node) {
			var children = node.childNodes;
			var numChildren = children.length;
			if ((node.nodeType === 3) && (numChildren === 0)) {
				var text = node.data;
				if (text && (text.length > 25)) {
					arr.push(node);
				}
			} else {
				var i;
				for (i = 0; i < numChildren; i++) {
					var child = children[i];
					var tagName = child.tagName;
					var isProhibitedTag = tagName && ((tagName === 'A') || (tagName === 'META') || (tagName === 'FORM') || (tagName === 'LABEL') || (tagName === 'SCRIPT') || (tagName === 'STYLE') || (tagName === 'OPTION') || (tagName === 'BUTTON') || (tagName === 'INPUT') || (tagName === 'TEXTAREA') || (tagName === 'H1') || (tagName === 'H2') || (tagName === 'H3'));
					if (!isProhibitedTag) {
						addTextNodesToArray(child, arr);
					}
				}
			}
		}
	}

	function addSearchLinks(terms, textNodes, slType) {
		// recursively "loop" over terms, calling processSearchLinksTerm() on each term.
		// since this may be slow, use setTimeout to yield the CPU between loop iterations.
		if (terms.length) {
			processSearchLinksTerm(terms.pop(), textNodes, slType);

			// the previous line shortened the terms list by 1. if we still have more
			// terms, then recurse. otherwise, we're done, so call viglink.
			if (terms.length && (scGetTime() - scSearchLinksInvocationTimestamp < 9999)) {
				setTimeout(function () {
					addSearchLinks(terms, textNodes, slType);
				}, 15);
			} else {
				addVigLink();
			}
		}
	}

	function isCompany(term) {
		term = term.toLowerCase();
		return (term === 'amazon') || (term === 'apple') || (term === 'bing') || (term === 'blogspot') ||
		(term === 'ebay') || (term === 'facebook') || (term === 'gmail') || (term === 'google') ||
		(term === 'hotmail') || (term === 'linkedin') || (term === 'microsoft') || (term === 'pinterest') ||
		(term === 'quora') || (term === 'tumblr') || (term === 'twitter') || (term === 'wikipedia') ||
		(term === 'wordpress') || (term === 'yahoo') || (term === 'yandex') || (term === 'youtube');
	}

	function processSearchLinksTerm(term, textNodes, slType) {
		if (term && !isCompany(term)) {
			var numTextNodes = textNodes.length,
			i;
			for (i = 0; i < numTextNodes; i++) {
				var textNode = textNodes[i];
				var added = addSearchLinksToNode(term, textNode, slType);
				if (added) {
					break;
				}
			}
		}
	}

	function addSearchLinksToNode(term, textNode, slType) {
		var parentNode = textNode.parentNode;
		if (!parentNode) {
			return;
		}

		var queryFromRefinement;
		if (contains(term, '/')) {
			var arr = term.split('/');
			queryFromRefinement = arr[0];
			term = arr[1];
		}

		if (isStopWord(term)) {
			return;
		}

		if (queryFromRefinement && !contains(textNode.data.toLowerCase(), queryFromRefinement)) {
			return;
		}

		var matches = (new RegExp('\\b' + term + '[s]?\\b', 'i')).exec(textNode.data);
		if (matches) {
			var text = matches[0];
			var before = matches.input.substring(0, matches.index);
			var after = matches.input.substring(matches.index + text.length);
			text = text.replace(/\s+/g, " ");
			textNode.data = before;

			var query = (queryFromRefinement && !contains(text.toLowerCase(), queryFromRefinement)) ? (queryFromRefinement + ' ' + text) : text;
			var url = constructDestinationSiteUrl(query, 'sl' + slType);

			var aTag = make('a');
			aTag.setAttribute('href', url);
			aTag.setAttribute('target', 'scSearchLink');
			aTag.style.textDecoration = 'none';
			aTag.style.borderBottom = 'dotted';
			aTag.textContent = text;
			parentNode.insertBefore(aTag, textNode.nextSibling);

			var textNode2 = document.createTextNode(after);
			parentNode.insertBefore(textNode2, aTag.nextSibling);

			return 1;
		}
	}

	function constructDestinationSiteUrl(query, f) {
		var partner = SC.partner ? SC.partner.toLowerCase() : 'sc';
		return SC.host + 'search?q=' + encodeURIComponent(query) + '&f=' + f + '&p=' + partner;
	}

	function initNewFFInstallation() {
		var lastSeenSplash = getLastSeenSplash();
		var isNewInstall = !lastSeenSplash;

		SC.instId = getInstId();
		SC.partner = getPartner();

		SC.instTimestamp = getInstTimestamp();
		var versionNoDots = SC.extensionVersion.replace(/\./g, '');

		if (isNewInstall) {
			setLastSeenSplash(versionNoDots);

			sc_ajax({
				method : 'GET',
				url : SC.host + 'newInstall?p=' + SC.partner
			});
		} else if (lastSeenSplash && (lastSeenSplash !== versionNoDots)) {
			var displaySplashPage = 0; // value dynamically set in build.xml
			if (displaySplashPage) {
				setLastSeenSplash(versionNoDots);
				var splashUrl = SC.host + 'newInVersion' + versionNoDots + '.jsp';
				openNewTab(splashUrl);
			}
		}
	}

	function createGlobalData() {
		try {
			SC = {
				host : 'http://www.surfcanyon.com/',
				extensionVersion : '5.4.1'
			};

			if (scIsIE) {
				initIE();
			} else if (scIsFF) {
				initFF();

				// initNewFFInstallation requires SC.host and SC.extensionVersion to be set
				initNewFFInstallation();
			}

			// set prefs on first run. on IE, this needs to be after the initIE() call.
			var max = getCharPref("max_num_recs");
			if (!max) {
				setMaxNumRecsForSRSelection('3');
				setShowRecsOnSRClick(true);
			}

			// this section needs to be after initNewFFInstallation, since it initializes
			// these variables the first time the extension runs.
			mergeProperties(SC, {
				instId : getInstId(),
				instTimestamp : getInstTimestamp(),
				partner : getPartner()
			});

			if (typeof SC.currentDomain === 'undefined') {
				try {
					SC.currentDomain = window.location.host;
				} catch (e) {
				}
			}

			if (typeof SC.currentUrl === 'undefined') {
				try {
					SC.currentUrl = window.location.href;
				} catch (e) {
				}
			}

			if (typeof SC.currentTitle === 'undefined') {
				try {
					SC.currentTitle = document.title;
				} catch (e) {
				}
			}

			mergeProperties(SC, {
				searchEngine : null,
				query : null,
				prevQuery : null,
				queryChanged : false,
				queryChangedPrev : false,
				bufferedEvent : null,
				uploadResults : false,
				firstBatchReceived : false,
				continuingSession : false,
				gettingRecs : false,
				gettingMoreResults : false,
				goingToPage : false,
				refreshingDynamicContent : false,
				numUserActions : 0,
				srSelectionCount : 0,
				batchNum : 0,
				numBatchesLeftToUpload : 0,
				forceReinvokeExtensionInit : false,
				originalNavBar : null,
				originalNavBar2 : null,
				clickHandlers : []
			});
		} catch (e) {
		}
	}

	function initializeBooleanPreference(basePrefName, initialValue) {
		try {
			var prefName = basePrefName + '_enabled';
			var prefInitedName = 'initialized_' + basePrefName;
			if (!getBoolPreferenceValue(prefInitedName)) {
				setBoolPreferenceValue(prefName, initialValue);
				setBoolPreferenceValue(prefInitedName, true);
			}
		} catch (e) {
		}
	}

	function setup() {
		try {
			createGlobalData();
			if (typeof SC.currentDomain === 'undefined') {
				return;
			}

			installSCClickHandler();

			if (areRoamingSuggestionsOk()) {
				injectPredictAd();
			}

			try {
				var iframeHref = (window.top === window) ? document.location.href : document.referrer;
				if (iframeHref && !contains(iframeHref, SC.currentDomain) && !(onSCWebSitePage('scCustomizePage') || onSCWebSitePage('scSearchLinksPage'))) {
					return;
				}
			} catch (e) {
			}

			if (onSCWebSitePage('scCustomizePage')) {
				installSCClickHandler(document, customizePageClickHandler);
				if (scIsOldIE) {
					document.attachEvent('onkeydown', customizePageKeyHandler);
				}
				updateCustomizePage();
			} else if (onSCWebSitePage('scRoamingSuggestionsPage')) {
				addBooleanPreferenceButton('roaming_suggestions_button', getRoamingSuggestionsEnabled, setRoamingSuggestionsEnabled, 'Roaming Search Suggestions');
			} else if (onSCWebSitePage('scSearchLinksPage')) {
				addBooleanPreferenceButton('search_links_button', getSearchLinksEnabled, setSearchLinksEnabled, 'Search Links');
			} else if (onSCWebSitePage('scResetPage')) {
				setInstId(bigRandom());
			}

			if (onSCWebSitePage('scUserDataPage')) {
				var topLevel = make('div');
				var div = make('div');
				div.textContent = 'Version of surfcanyon.js: ' + SC.extensionVersion;
				topLevel.appendChild(div);
				div = make('div');
				div.textContent = 'InstId: ' + SC.instId;
				topLevel.appendChild(div);
				div = make('div');
				div.textContent = 'Partner: ' + SC.partner;
				topLevel.appendChild(div);
				div = make('div');
				div.textContent = 'Host: ' + SC.host;
				topLevel.appendChild(div);
				div = make('div');
				div.textContent = 'User Agent: ' + getUserAgent();
				topLevel.appendChild(div);
				document.body.appendChild(topLevel);
			} else if (onSCWebSitePage('scPreferencesPage')) {
				console.log('on SC page');
				try {
					fillInPreferencesPage();
				} catch (e) {
					console.log(e.message);
				}
			} else if (onGoogleSerp()) {
				SERP = new GoogleSERP();
			}

			if (SERP) {
				mergeProperties(SC, SERP.getBehavior());
				waitForSerpAjaxToComplete();
			} else {
				updateDynamicPreferences();
				setupSearchLinks();
			}

		} catch (e2) {
		}
	}

	function fillInPreferenceArrays(boolPreferences, charPreferences) {
		var preferences = []; // todo: get prefs list from build.xml
		preferences = ['disabled', 'dynamic_preferences_timestamp', 'get_recs_on_sr_click', 'google_search_button_click_ts', 'google_search_button_click_query', 'initialized_roaming_suggestions', 'initialized_search_links',  'initialized_ss_page_links', 'inst_id', 'inst_timestamp', 'last_seen_splash', 'max_num_recs', 'num_recs_clicked', 'num_results_clicked', 'num_results_clicked_when_recs_available', 'num_searches', 'odometer_disabled', 'partner_code', 'refinements_cache', 'roaming_suggestions_enabled', 'search_links_enabled', 'ss_page_links_enabled', 'debug'];

		var name, isBoolean;
		for (var i = 0; i < preferences.length; i++) {
			name = preferences[i];
			isBoolean = startsWith(name, 'init') || endsWith(name, 'abled') || (name === 'get_recs_on_sr_click');
			if (isBoolean) {
				boolPreferences.push(name);
			} else {
				charPreferences.push(name);
			}
		}

		if (scIsIE) {
			charPreferences.push('mode');
		}
	}

	function fillInPreferencesPage() {
		console.log('filling in preferences');
		logger.debug();
		var boolPreferences = [];
		var charPreferences = [];
		fillInPreferenceArrays(boolPreferences, charPreferences);

		var mainDiv = make('div');
		var table = make('table');
		table.style.marginBottom = '20px';
		mainDiv.appendChild(table);
		var i, tr, td, name, value, label, input, html, div;
		for (i = 0; i < boolPreferences.length; i++) {
			if (i % 3 === 0) {
				tr = make('tr');
				table.appendChild(tr);
			}

			name = boolPreferences[i];
			value = getBoolPref(name);
			html = '<label><input type="checkbox" id="' + name + '"' + (value ? ' checked=true' : '') + '>' + name + '</label>';

			td = make('td');
			td.style.paddingRight = '20px';
			tr.appendChild(td);
		}
		for (i = 0; i < charPreferences.length; i++) {
			name = charPreferences[i];
			value = getCharPref(name) || '';
			label = '<label for="' + name + '">' + name + '</label>';
			input = (name === 'refinements_cache') ?
			('<textarea rows="10" cols="100" id="' + name + '">' + value + '</textarea>') :
			('<input type="text" size=40 id="' + name + '" value="' + value + '">');
			html = label + ': ' + input;

			div = make('div');
			mainDiv.appendChild(div);
		}
		var saveButton = make('button');
		saveButton.style.margin = '20px';
		saveButton.textContent = 'Save Preferences';
		installSCClickHandler(saveButton, savePreferences);
		mainDiv.appendChild(saveButton);
		document.body.appendChild(mainDiv);
	}

	function savePreferences() {
		if (!onSCWebSitePage('scPreferencesPage')) {
			return;
		}

		var boolPreferences = [];
		var charPreferences = [];
		fillInPreferenceArrays(boolPreferences, charPreferences);

		var i, name, value;
		for (i = 0; i < charPreferences.length; i++) {
			try {
				name = charPreferences[i];
				value = getById(name).value;
				setCharPreferenceValue(name, value);
			} catch (e) {
			}
		}
		for (i = 0; i < boolPreferences.length; i++) {
			try {
				name = boolPreferences[i];
				value = getById(name).checked;
				setBoolPreferenceValue(name, value);
			} catch (e) {
			}
		}

		alert('Preferences saved');
	}

	function addBooleanPreferenceButton(divId, getter, setter, name) {
		var div = getById(divId);
		var isOn = false;
		try {
			isOn = getter();
		} catch (e) {
		}
		addPrefButtonToDiv(div, name, isOn);

		installSCClickHandler(div, function () {
			var isOn = false;
			try {
				isOn = getter();
			} catch (e) {
			}
			isOn = !isOn;

			setter(isOn);
			addPrefButtonToDiv(div, name, isOn);
		});
	}

	function addPrefButtonToDiv(div, name, isOn) {
		var button = make('button');
		button.textContent = 'Turn ' + name + ' ' + (isOn ? 'OFF' : 'ON');
		removeChildNodes(div);
		div.appendChild(button);
	}

	function removeChildNodes(node) {
		while (node.firstChild) {
			node.removeChild(node.firstChild);
		}
	}

	function addPageStyle(css) {
		var head = getTags('head')[0];

		var style = make('style');
		style.type = 'text/css';
		if (style.styleSheet) {
			style.styleSheet.cssText = css;
		} else {
			style.appendChild(document.createTextNode(css));
		}

		head.appendChild(style);
	}

	function getQueryFromGoogleSerp() {
		var aTags = getTags('a'),
		i,
		len = aTags.length;
		for (i = 0; i < len; i++) {
			var aTag = aTags[i];
			var href = aTag.href;
			if ((contains(href, '.google.') || href.charAt(0) == '/') && (contains(href, '/advanced_search?q=') || contains(href, '/swr?q='))) {
				SC.query = href.replace(/.*\?q=/, '').replace(/&.*/, '');
				return;
			}
		}
	}

	function googleAjaxPollingLoop() {
		SC.prevQuery = SC.query;
		SC.queryChangedPrev = SC.queryChanged;

		getQueryFromGoogleSerp();
		SC.queryChanged = (SC.query != SC.prevQuery);

		var invoke = (SC.queryChangedPrev && !SC.queryChanged) || SC.forceReinvokeExtensionInit;
		SC.forceReinvokeExtensionInit = false;
		var didIt = invoke ? setupForExtensionInit() : false;
		if (!didIt) {
			setTimeout(googleAjaxPollingLoop, 900);
		}
	}

	function waitForSerpAjaxToComplete() {
		if (!SC.query && onGoogleSerp()) {
			getQueryFromGoogleSerp();

			if (!SC.query) {
				setTimeout(waitForSerpAjaxToComplete, 1000);
				return;
			}
		}

		if (!setupForExtensionInit()) {
			setTimeout(waitForSerpAjaxToComplete, 1000);
			return;
		}
	}

	function setupForExtensionInit() {
		if (!SC.query) {
			logger.debug('no query found');
			return false;
		}
		SC.query = decodeEntities(SC.query);

		scSRNodes = SERP.scGetSRNodes(null);
		if (!scSRNodes || (scSRNodes.length === 0)) {
			return false;
		}

		if (scIsFF || scIsSafari) {
			window.addEventListener('pageshow', pageshowHandler, false);
			window.addEventListener('pagehide', pagehideHandler, false);
		}

		if (!getAllDisabled()) {
			try {
				callExtensionInit();
			} catch (e) {
			}
		}

		return true;
	}

	function constructSearchResultURLListArgs() {
		var srURLs = '';
		var httpArgs = '';
		var numResults = scSRNodes.length;
		var i;
		for (i = 0; i < numResults; i++) {
			var srNode = scSRNodes[i];
			var displayUrl = SERP.extractUrlFromSRNode(srNode);
			if (displayUrl) {
				var urlHash = getUrlHash(displayUrl);
				srURLs = (srURLs ? (srURLs + ',' + urlHash) : urlHash);

				var realUrl;
				try {
					var titleTag = getTitleTag(srNode);
					var aTag = getChildrenByTagName(titleTag, "a")[0];
					httpArgs = httpArgs + '&title' + i + '=' + encodeURIComponent(aTag.innerHTML);

					var guessAtClickUrl = aTag.href; // it's a guess since some oddly formatted results might have the first link not be the clickable title link
					if (getDomainName(guessAtClickUrl) === getDomainName(displayUrl)) {
						realUrl = guessAtClickUrl;
					} else {
						realUrl = displayUrl;
					}
				} catch (ee) {}

				httpArgs = httpArgs + '&url' + i + '=' + encodeURIComponent(realUrl);
			}
		}

		return '&nativeSerpSearchResultUrls=' + srURLs + httpArgs + '&numResultsOnPage=' + numResults;
	}

	function callExtensionInit() {
		var srDataArgs = constructSearchResultURLListArgs();
		sc_ajax({
			method : 'POST',
			url : SC.host + 'search/extensionInit',
			headers : {
				'Content-type' : 'application/x-www-form-urlencoded'
			},
			data : 'ssMapKey=' + getSSMapKey() +
			'&serpUrl=' + encodeURIComponent(getPageUrl()) +
			'&instId=' + SC.instId +
			'&p=' + SC.partner +
			'&instTimestamp=' + SC.instTimestamp +
			'&extensionVersion=' + SC.extensionVersion +
			'&searchString=' + encodeURIComponent(SC.query) +
			'&searchEngine=' + SC.searchEngine +
			'&lang=' + getLangFromDomain(SC.currentDomain) +
			'&numResultsPerPage=' + getNumResultsPerPage() +
			srDataArgs,
			onload : function (xhr) {

				var text = getResponseText(xhr);

				if (isOkServerResponse(text)) {
					var xmlRoot = scXmlParser(text);
					var data = xmlRoot.getElementsByTagName('data')[0];
					if (data) {
						var userStatusNode = data.getElementsByTagName('userStatus')[0];
						scUserStatus = userStatusNode ? scGetText(userStatusNode) : "";

						if (scUserStatus != '0') {
							var sessionStatusNode = data.getElementsByTagName('sessionStatus')[0];
							if (sessionStatusNode) {
								processDataFromExtensionInit(data);
								if (!getAllDisabled()) {
									var node = data.getElementsByTagName('notEnoughResults')[0];
									if (scGetText(node) != '1') {
										initUI();
									}

									var sessionStatus = scGetText(sessionStatusNode);
									if (sessionStatus == '1') {
										if (SC.uploadResults) {
											SC.numBatchesLeftToUpload = SC.numSRsForInitialUpload / SC.batchSize;
											SC.batchNum = 1;
											uploadSRs();
										} else {
											// server received first batch via API instead of via upload
											SC.firstBatchReceived = true;
										}
										incNumSearches();
									} else {
										SC.continuingSession = true;
									}

									if (SC.continuingSession) {
										refreshDynamicContent();
									}

									if (onGoogleSerp()) {
										googleAjaxPollingLoop();
									}
								}
							}
						} else {
							if (onGoogleSerp()) {
								googleAjaxPollingLoop();
							}
						}
					}
				}
			}
		});
	}

	function processDataFromExtensionInit(data) {
		var numUserActionsNode = data.getElementsByTagName('numUserActions')[0];
		SC.numUserActions = scGetText(numUserActionsNode) === '1';

		var uploadResultsNode = data.getElementsByTagName('uploadResults')[0];
		SC.uploadResults = scGetText(uploadResultsNode) === '1';
	}

	function isOnSecurePage() {
		return (window.location.protocol === 'https:');
	}

	function isOnProtectedDomain() {
		var domain = SC.currentDomain;
		return onSCPage() || contains(domain, '.google.') || contains(domain, '.yahoo.') || contains(domain, '.bing.') || contains(domain, '.live.') || contains(domain, 'mail.') || contains(domain, 'calendar.') || endsWith(domain, '.gov') || endsWith(domain, '.mil');
	}

	function isOnDataPage() {
		var url = window.location.href;
		return endsWith(url, '.pdf') || endsWith(url, '.txt') || endsWith(url, '.xml') || endsWith(url, '.json');
	}

	function disableMostExtraFeatures(scSerpOk) {
		return isOnDataPage() || (isOnProtectedDomain() && !(scSerpOk && onSCSerp()));
	}

	function isVigLinkOk() {
		return !(isOnSecurePage() || disableMostExtraFeatures());
	}

	function areRoamingSuggestionsOk() {
		var domain = SC.currentDomain;
		return getRoamingSuggestionsEnabled() && !(isOnSecurePage() || disableMostExtraFeatures() || endsWith(domain, 'netflix.com') || endsWith(domain, 'opentable.com'));
	}

	function areSearchLinksOk() {
		return getSearchLinksEnabled() && !disableMostExtraFeatures();
	}

	function injectPredictAd() {
	}

	function setupSearchLinks() {
		if (!areSearchLinksOk() || (typeof scSearchLinksInvoked !== 'undefined')) {
			return;
		}
		scSearchLinksInvoked = true;

		clientSideSearchLinks();
	}

	function addVigLink() {
		if (!areSearchLinksOk() || (typeof scVigLinksInvoked !== 'undefined')) {
			return;
		}
		scVigLinksInvoked = true;




	}

	function isStopWord(s) {
		var stopwords = ['the', 'of', 'and', 'a', 'an', 'to', 'in', 'is', 'you', 'that', 'it',
			'about', 'above', 'across', 'after', 'afterward', 'again', 'against', 'all',
			'almost', 'along', 'already', 'also', 'although', 'always', 'among', 'another',
			'any', 'anyhow', 'anyone', 'anything', 'anyway', 'anywhere', 'are', 'area',
			'around', 'as', 'at', 'away', 'back', 'be', 'became', 'because', 'become',
			'becoming', 'been', 'before', 'beforehand', 'behind', 'being', 'below', 'beside',
			'between', 'beyond', 'big', 'both', 'but', 'by', 'call', 'can', 'cannot',
			'could', 'did', 'do', 'does', 'done', 'down', 'due', 'during', 'each', 'either',
			'else', 'elsewhere', 'empty', 'etc', 'even', 'ever', 'every', 'everyone',
			'everything', 'everywhere', 'except', 'for', 'former', 'from', 'further',
			'get', 'good', 'had', 'have', 'he', 'her', 'here', 'herself', 'him', 'himself',
			'his', 'how', 'however', 'if', 'into', 'its', 'itself', 'join', 'just', 'keep',
			'last', 'least', 'less', 'let', 'like', 'many', 'may', 'might', 'more', 'most',
			'much', 'must', 'myself', 'near', 'nearby', 'neither', 'never', 'next',
			'no', 'nobody', 'none', 'nor', 'not', 'nothing', 'now', 'nowhere', 'off',
			'often', 'on', 'once', 'one', 'only', 'onto', 'or', 'other', 'otherwise',
			'our', 'ours', 'out', 'over', 'own', 'per', 'perhaps', 'put', 'rather',
			'see', 'seem', 'self', 'set', 'several', 'she', 'should', 'sign', 'since',
			'so', 'some', 'somehow', 'someone', 'something', 'sometime', 'sometimes',
			'somewhere', 'still', 'such', 'than', 'their', 'theirs', 'them', 'then',
			'there', 'these', 'they', 'this', 'those', 'though', 'through', 'throughout',
			'thru', 'too', 'toward', 'under', 'until', 'up', 'upon', 'very', 'was', 'way',
			'well', 'went', 'were', 'what', 'whatever', 'when', 'whenever',
			'where', 'wherever', 'whether', 'which', 'while', 'who', 'whoever', 'whom',
			'whose', 'why', 'will', 'with', 'within', 'without', 'word', 'would',
			'yet', 'your', 'yourself'];

		var i,
		num = stopwords.length;
		for (i = 0; i < num; i++) {
			if (stopwords[i] === s) {
				return true;
			}
		}

		return false;
	}

	function domainIs(d) {
		return (SC.currentDomain === d) || endsWith(SC.currentDomain, '.' + d);
	}

	function onFacebookPage() {
		return domainIs('facebook.com') && !contains(getPageUrl(), '/messages/');
	}

	function onSCSerp() {
		return onSCPage() && getById('formWithSuggest') && getById('dynamicContent');
	}

	function onSCPage() {
		return domainIs('surfcanyon.com') || (SC.currentDomain == 'localhost');
	}

	try {
		if (scIsIE) {
			if (document.readyState === 'complete') {
				// 5.2.0 DLL and higher
				setup();
			} else {
				// older DLLs
				if (window.frames.length) {
					var i;
					for (i = 0; i < window.frames.length; i++) {
						try {
							window.frames[i].attachEvent('onload', setup);
						} catch (e) {}
					}
				} else {
					window.attachEvent('onload', setup);
				}
			}
		} else if (!scInitializedByBackgroundPage) {
			setup();
		}
	} catch (ee) {}
} catch (e) {
}



//FOR-IE }; // closes surfcanyonWrapperObject
//FOR-IE surfcanyonWrapperObject();

